#include <OOPGDIP.au3>

__OOPGDIP_TestBeispiel()

Func __OOPGDIP_TestBeispiel()
	Local $hGUI, $hImage
	Local $oGDIPGraphic, $oGDIPLine, $oGDIPPen, $oGDIPBrush, $oGDIPRect, $oGDIPEllipse, $oGDIPFilledEllipse, $oGDIPFilledRect, $oGDIPPolygon, $oGDIPFilledPolygon, $oGDIPBuffer, $oGDIPPie, $oGDIPClosedCurve, $oGDIPFilledClosedCurve, $oGDIPCurve, $oGDIPBezier, $oGDIPImage, $oGDIPString, $oGDIPFont, $oGDIPStringEx[2]
	Local $aPolygonCords[4][2] = [[3],[300, 30],[300, 160],[400, 160]]
	Local $aCurveCords[5][2] = [[4],[20, 100],[50, 50],[100, 100],[150, 50]]
	Local $ImageRotation = True

	$hGUI = GUICreate("OOPGDIP = AutoIt + OOP + GDI+ ~-~ Funktionstest", 500, 500, -1, -1)
	GUISetBkColor(0x6544AB)
	GUISetState()

	_OOPGDIP_Startup()

	$hImage = _GDIPlus_ImageLoadFromFile("NosHacks Logo_trans.png")

	$oGDIPGraphic = _OOPGDIP_GraphicsCreate($hGUI)
	$oGDIPBuffer = _OOPGDIP_BufferCreate($oGDIPGraphic, 500, 500, 0xFF6544AB, 4)
	$oGDIPPen = _OOPGDIP_PenCreate(0xFF00FF00)
	$oGDIPBrush = _OOPGDIP_BrushCreate(0xFFFF0000)
	$oGDIPLine = _OOPGDIP_LineCreate($oGDIPBuffer, 10, 40, 100, 200, $oGDIPPen)
	$oGDIPRect = _OOPGDIP_RectCreate($oGDIPBuffer, 10, 40, 100, 200, $oGDIPPen)
	$oGDIPEllipse = _OOPGDIP_EllipseCreate($oGDIPBuffer, 200, 200, 170, 100, $oGDIPPen, 0, 320)
	$oGDIPPie = _OOPGDIP_PieCreate($oGDIPBuffer, 300, 300, 170, 100, $oGDIPPen, 0, 320)
	$oGDIPFilledEllipse = _OOPGDIP_FilledEllipseCreate($oGDIPBuffer, 300, 300, 170, 100, $oGDIPBrush, 0, 320)
	$oGDIPFilledRect = _OOPGDIP_FilledRectCreate($oGDIPBuffer, 10, 300, 200, 100, $oGDIPBrush)
	$oGDIPPolygon = _OOPGDIP_PolygonCreate($oGDIPBuffer, $aPolygonCords, $oGDIPPen)
	$oGDIPFilledPolygon = _OOPGDIP_FilledPolygonCreate($oGDIPBuffer, $aPolygonCords, $oGDIPBrush)
	$oGDIPClosedCurve = _OOPGDIP_ClosedCurveCreate($oGDIPBuffer, $aPolygonCords, $oGDIPPen)
	$oGDIPFilledClosedCurve = _OOPGDIP_FilledClosedCurveCreate($oGDIPBuffer, $aPolygonCords, $oGDIPBrush)
	$oGDIPCurve = _OOPGDIP_CurveCreate($oGDIPBuffer, $aCurveCords, $oGDIPPen)
	$oGDIPBezier = _OOPGDIP_BezierCreate($oGDIPBuffer, 30, 50, 100, 5, 125, 25, 250, 50, $oGDIPPen)
	$oGDIPImage = _OOPGDIP_ImageCreate($oGDIPBuffer, $hImage, 10, 500 - 40)
	$oGDIPString = _OOPGDIP_StringCreate($oGDIPBuffer, "Test", 100, 100, "Blackadder ITC", 100)
	$oGDIPFont = _OOPGDIP_FontCreate(70, "Curlz MT", 1, 1)
	$oGDIPStringEx[0] = _OOPGDIP_StringExCreate($oGDIPBuffer, "TestEx1", 0, 0, 400, 100, $oGDIPFont, $oGDIPBrush)
	$oGDIPStringEx[1] = _OOPGDIP_StringExCreate($oGDIPBuffer, "TestEx2", 0, 100, 400, 100, $oGDIPFont, $oGDIPBrush)


	While GUIGetMsg() <> -3
		Sleep(20)
		$oGDIPBuffer.clear
		If $oGDIPImage.width1 >= -214 And $ImageRotation Then
			$oGDIPImage.x1Pos = $oGDIPImage.x1Pos + 1
			$oGDIPImage.width1 = $oGDIPImage.width1 - 2
			If $oGDIPImage.width1 = -214 Then $ImageRotation = False
		Else
			$oGDIPImage.x1Pos = $oGDIPImage.x1Pos - 1
			$oGDIPImage.width1 = $oGDIPImage.width1 + 2
			If $oGDIPImage.width1 = 214 Then $ImageRotation = True
		EndIf
		$oGDIPImage.draw
		$oGDIPLine.draw
		$oGDIPRect.draw
		$oGDIPFilledEllipse.sangle = $oGDIPFilledEllipse.sangle + 2
		$oGDIPFilledEllipse.draw
		$oGDIPEllipse.draw
		$oGDIPPie.sangle = $oGDIPPie.sangle + 2
		$oGDIPPie.draw
		$oGDIPFilledRect.draw
		$oGDIPFilledClosedCurve.draw
		$oGDIPClosedCurve.draw
		$oGDIPFilledPolygon.draw
		$oGDIPPolygon.draw
		$oGDIPCurve.draw
		$oGDIPBezier.draw
		$oGDIPString.draw
		If $oGDIPStringEx[0].xPos <= 200 Then $oGDIPStringEx[0].xPos = $oGDIPStringEx[0].xPos + 1
		$oGDIPStringEx[0].update
		$oGDIPStringEx[0].draw
		If $oGDIPStringEx[1].yPos <= 380 Then $oGDIPStringEx[1].yPos = $oGDIPStringEx[1].yPos + 1
		$oGDIPStringEx[1].update
		$oGDIPStringEx[1].draw
		$oGDIPBuffer.draw
	WEnd

	_GDIPlus_ImageDispose($hImage)

	$oGDIPBrush.dispose
	$oGDIPPen.dispose
	$oGDIPBuffer.dispose
	$oGDIPGraphic.dispose
	_OOPGDIP_Shutdown()
	Exit
EndFunc   ;==>__OOPGDIP_TestRun